---
title: Firefox 79 for developers
slug: Mozilla/Firefox/Releases/79
tags:
  - '79'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 79 that will affect developers. Firefox 79 was released on July 28, 2020.</p>

<p class="summary">See also <a href="https://hacks.mozilla.org/2020/07/firefox-79/">Firefox 79: The safe return of shared memory, new tooling, and platform updates</a> on Mozilla hacks.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<h4 id="Console">Console</h4>

<ul>
 <li>Network messages with response codes in the 400-499 and 500-599 ranges are now considered errors, and are displayed <a href="/en-US/docs/Tools/Web_Console/Console_messages#Filtering_by_category">even if Reponse or XHR filters are disabled</a>. ({{bug(1635460)}})</li>
 <li>Network messages for requests that are blocked (by the browser or an extension) are now styled with a "prohibited" icon in the <a href="/en-US/docs/Tools/Web_Console/Console_messages">Console</a>. ({{bug(1629875)}})</li>
</ul>

<h4 id="Debugger">Debugger</h4>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Black_box_a_source">"Blackbox" a source file</a> is now called "ignore" a source file.  ({{bug(1642811)}})</li>
 <li><span><span>Inline preview is now available on <a href="/en-US/docs/Tools/Debugger/How_to/Breaking_on_exceptions">exceptions</a>. ({{bug(1581708)}})</span></span></li>
 <li><span><span>Items in the Watch Expressions and Scopes sections now have tooltips on hover, showing their values ({{bug(1631545)}})</span></span></li>
 <li><span><span>In the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Call_stack">Call Stack section</a>, there is now a context menu option to <strong>Restart Frame</strong>, to execute the current stack frame from its beginning. ({{bug(1594467)}})</span></span></li>
</ul>

<h4 id="Other_tools"><span>Other tools</span></h4>

<ul>
 <li>The new <a href="/en-US/docs/Tools/Application">Application panel</a> is now available, which initially provides inspection and debugging support for <a href="/en-US/docs/Web/API/Service_Worker_API">service workers</a> and <a href="/en-US/docs/Web/Manifest">web app manifests</a>.</li>
 <li><span><span>The Messages tab of the Network Monitor has been merged with the <a href="/en-US/docs/Tools/Network_Monitor/request_details#Response_tab">Responses tab</a>. ({{bug(1636421)}})</span></span></li>
 <li><span><span>The Accessibility Inspector is automatically turned on when you access its tab; you no longer need to explicitly enable it. ({{bug(1602075)}})</span></span></li>
 <li>In <a href="/en-US/docs/Tools/Responsive_Design_Mode#Controlling_Responsive_Design_Mode">Responsive Design Mode</a>, when touch simulation is enabled, mouse-drag events are now interpreted as touch-drag or swipe events. ({{bug(1621781)}})</li>
 <li>When <a href="/en-US/docs/Tools/about:debugging#Connecting_to_a_remote_device">remote debugging</a>, the URL bar now has <strong>Back</strong> and <strong>Forward</strong> buttons to help with navigation on the remote browser. ({{bug(1639425)}})</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The <code><a href="/en-US/docs/Web/HTML/Element/iframe">&lt;iframe&gt;</a></code> element's <code>sandbox</code> attribute now supports the <code>allow-top-navigation-by-user-activation</code> token ({{bug(1359867)}}).</li>
 <li>Setting <code>target="_blank"</code> on <code><a href="/en-US/docs/Web/HTML/Element/a">&lt;a&gt;</a></code> and <code><a href="/en-US/docs/Web/HTML/Element/area">&lt;area&gt;</a></code> elements implicitly provides the same behavior as also setting <code>rel="noopener"</code> ({{bug(1522083)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>External style sheets are now cached per document group ({{bug(1599160)}}). Firefox will minimize retrieval and revalidation of cached style sheets when navigating pages on the same origin. A simple reload (for example, <kbd>F5</kbd>) will not revalidate the cached CSS files. To load current versions of the style sheets, reload the page bypassing the cache (<kbd>Cmd</kbd>/<kbd>Ctrl</kbd> + <kbd>F5</kbd>).</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The <code><a href="/en-US/docs/Web/CSS/@media/prefers-color-scheme">prefers-color-scheme</a></code> media feature's <code>no-preference</code> value has been removed from the <a href="https://drafts.csswg.org/mediaqueries-5/#descdef-media-prefers-color-scheme">media queries spec</a>, and from Firefox ({{bug(1643656)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>{{jsxref("SharedArrayBuffer")}} has been re-enabled in a post-Spectre-safe manner. It is available to cross-origin isolated sites ({{bug(1619649)}}).
  <ul>
   <li>To cross-origin isolate your site, you need to set the new {{HTTPHeader("Cross-Origin-Embedder-Policy")}} (COEP) and {{HTTPHeader("Cross-Origin-Opener-Policy")}} (COOP) headers.</li>
  </ul>
 </li>
 <li>{{jsxref("Promise.any()")}} is now available ({{bug(1599769)}}).</li>
 <li>{{jsxref("WeakRef")}} objects have been implemented ({{bug(1639246)}}).</li>
 <li><a href="https://github.com/tc39/proposal-logical-assignment">Logical assignment operators</a> are now supported ({{bug(1639591)}})
  <ul>
   <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_nullish_assignment">Logical nullish assignment (<code>??=</code>)</a></li>
   <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_AND_assignment">Logical AND assignment (<code>&amp;&amp;=</code>)</a></li>
   <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_OR_assignment">Logical OR assignment (<code>||=</code>)</a></li>
  </ul>
 </li>
 <li>{{jsxref("Atomics")}} objects now also work with non-shared memory ({{bug(1630706)}}).</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/DateTimeFormat/DateTimeFormat"><code>Intl.DateTimeFormat()</code> constructor </a>now supports the <code>dateStyle</code> and <code>timeStyle</code> options ({{bug(1557718)}}).</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/NumberFormat/NumberFormat"><code>Intl.NumberFormat()</code> constructor </a>now supports more numbering systems ({{bug(1413504)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>Cross-origin isolation has been implemented using the new {{HTTPHeader("Cross-Origin-Embedder-Policy")}} (COEP) and {{HTTPHeader("Cross-Origin-Opener-Policy")}} (COOP) headers. This allows you to access certain features such as {{jsxref("SharedArrayBuffer")}} objects and unthrottled timers in {{domxref("Performance.now()")}}.</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The <code><a href="/en-US/docs/Web/API/FileReader">FileReader</a></code> interface's <a href="/en-US/docs/Web/API/FileReader/loadstart_event"><code>loadstart</code> event</a> is now dispatched asynchronously, as per the spec ({{bug(1502403)}}).</li>
 <li>{{domxref("CanvasPattern.setTransform()")}} now supports a {{domxref("DOMMatrix")}} object as an input parameter, as well as an {{domxref("SVGMatrix")}} object ({{bug(1565997)}}).</li>
</ul>

<h4 id="Media_WebRTC_and_Web_Audio">Media, WebRTC, and Web Audio</h4>

<ul>
 <li>Firefox now supports remote timestamps on statistics records whose {{domxref("RTCStatsType")}} is <code>remote-outbound-rtp</code>. The {{domxref("RTCRemoteOutboundRtpStreamStats")}} dictionary which is used to provide these statistics now includes the {{domxref("RTCRemoteOutboundRtpStreamStats.remoteTimestamp", "remoteTimestamp")}} property, which states the timestamp on the remote peer at which the statistics were collected or generated ({{bug(1615191)}}).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>A number of internal Gecko events — including <code>DOMWindowClose</code> — which were accidentally exposed to the web, are now internal-only as intended ({{bug(1557407)}}).</li>
</ul>

<h3 id="WebAssembly">WebAssembly</h3>

<ul>
 <li><a href="/en-US/docs/WebAssembly/Understanding_the_text_format#Bulk_memory_operations">WebAssembly Bulk memory operations</a> are now shipped ({{bug(1528294)}}).</li>
 <li><a href="/en-US/docs/WebAssembly/Understanding_the_text_format#Reference_types">WebAssembly Reference types</a> are now shipped ({{bug(1637884)}}).</li>
 <li><a href="/en-US/docs/WebAssembly/Understanding_the_text_format#WebAssembly_threads">WebAssembly Threads</a> (Shared memory &amp; Atomics) are now shipped ({{bug(1389458)}}, {{bug(1648685)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<ul>
 <li>New API: <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/warmup">tabs.warmup()</a></code> (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1402256">bug 1402256</a>)</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/storage/sync#Storage_quotas_for_sync_data">Storage quotas are now enforced for the <code>sync</code> storage area</a> (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1634615">bug 1634615</a>) (<a href="https://blog.mozilla.org/addons/2020/07/09/changes-to-storage-sync-in-firefox-79/">addons.mozilla.org blog post</a>)</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/79/">Site compatibility for Firefox 79</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(78)}}</p>
